import { RenderFunction, VNodeChild } from 'vue';

interface TableData {
    key?: string;
    expand?: string | RenderFunction;
    children?: TableData[];
    disabled?: boolean;
    isLeaf?: boolean;
    [name: string]: any;
}
declare type OperationName = 'selection-checkbox' | 'selection-radio' | 'expand' | 'drag-handle';
interface TableOperationColumn {
    name: OperationName | string;
    title?: string | RenderFunction;
    width?: number;
    fixed?: boolean;
    render?: (record: TableData) => VNodeChild;
    isLastLeftFixed?: boolean;
}
interface TableComponents {
    operations: (operations: {
        dragHandle?: TableOperationColumn;
        expand?: TableOperationColumn;
        selection?: TableOperationColumn;
    }) => TableOperationColumn[];
}

export type { OperationName, TableComponents, TableData, TableOperationColumn };
